xfs
[Top] [All Lists]

[PATCH 5/5] xfstests: test 197, add a testcase for d_off truncation

To: xfs@xxxxxxxxxxx
Subject: [PATCH 5/5] xfstests: test 197, add a testcase for d_off truncation
From: Christoph Hellwig <hch@xxxxxxxxxxxxx>
Date: Tue, 30 Dec 2008 18:08:15 -0500
References: <20081230230810.986105000@xxxxxxxxxxxxxxxxxxxxxx>
User-agent: quilt/0.46-1
Make sure our directory offsets fit into a 32 bit value.
Based on a report by John Stanley.


Signed-off-by: Christoph Hellwig <hch@xxxxxx>

Index: xfstests/src/Makefile
===================================================================
--- xfstests/src/Makefile       2008-12-30 14:35:02.000000000 +0000
+++ xfstests/src/Makefile       2008-12-30 14:36:01.000000000 +0000
@@ -15,7 +15,7 @@
 LINUX_TARGETS = loggen xfsctl bstat t_mtab getdevicesize \
        preallo_rw_pattern_reader preallo_rw_pattern_writer ftrunc trunc \
        fs_perms testx looptest locktest unwritten_mmap \
-       bulkstat_unlink_test bulkstat_unlink_test_modified
+       bulkstat_unlink_test bulkstat_unlink_test_modified t_dir_offset
 
 IRIX_TARGETS = open_unlink
 
Index: xfstests/src/t_dir_offset.c
===================================================================
--- /dev/null   1970-01-01 00:00:00.000000000 +0000
+++ xfstests/src/t_dir_offset.c 2008-12-30 14:35:05.000000000 +0000
@@ -0,0 +1,62 @@
+
+#include <fcntl.h>
+#include <stdio.h>
+#include <unistd.h>
+#include <stdint.h>
+#include <stdlib.h>
+#include <sys/stat.h>
+#include <sys/syscall.h>
+
+struct linux_dirent64 {
+       uint64_t        d_ino;
+       int64_t         d_off;
+       unsigned short  d_reclen;
+       unsigned char   d_type;
+        char           d_name[0];
+};
+
+
+#define BUF_SIZE 4096
+
+int
+main(int argc, char *argv[])
+{
+       int fd, nread;
+       char buf[BUF_SIZE];
+       struct linux_dirent64 *d;
+       int bpos;
+
+       fd = open(argv[1], O_RDONLY | O_DIRECTORY);
+       if (fd < 0) {
+               perror("open");
+               exit(EXIT_FAILURE);
+       }
+
+       for ( ; ; ) {
+               nread = syscall(SYS_getdents64, fd, buf, BUF_SIZE);
+               if (nread == -1) {
+                       perror("getdents");
+                       exit(EXIT_FAILURE);
+               }
+
+               if (nread == 0)
+                       break;
+
+               for (bpos = 0; bpos < nread;) {
+                       d = (struct linux_dirent64 *) (buf + bpos);
+                       /*
+                        * Can't use off_t here xfsqa is compiled with
+                        * -D_FILE_OFFSET_BITS=64
+                        */
+                       if (d->d_off != (long)d->d_off) {
+                               fprintf(stderr, "detected d_off truncation "
+                                               "d_name = %s, d_off = %lld\n",
+                                               d->d_name, (long long)d->d_off);
+                               exit(EXIT_FAILURE);
+                       }
+                       bpos += d->d_reclen;
+               }
+       }
+
+       exit(EXIT_SUCCESS);
+}
Index: xfstests/group
===================================================================
--- xfstests/group      2008-12-30 14:35:02.000000000 +0000
+++ xfstests/group      2008-12-30 14:35:05.000000000 +0000
@@ -299,3 +299,4 @@
 194 rw auto
 195 ioctl dump auto
 196 quota auto
+197 dir auto
Index: xfstests/197
===================================================================
--- /dev/null   1970-01-01 00:00:00.000000000 +0000
+++ xfstests/197        2008-12-30 14:35:05.000000000 +0000
@@ -0,0 +1,49 @@
+#! /bin/sh
+# FS QA Test No. 197
+#
+# Check that d_off can be represented in a 32 bit long type without
+# truncation.
+#
+# Based on a testcase from John Stanley <jpsinthemix@xxxxxxxxxxx>.
+#
+# http://oss.sgi.com/bugzilla/show_bug.cgi?id=808
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2008 Christoph Hellwig.
+#-----------------------------------------------------------------------
+#
+# creator
+owner=hch@xxxxxx
+
+seq=`basename $0`
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1       # failure is the default!
+
+_cleanup()
+{
+       rm -rf $TEST_DIR/ttt
+}
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+# get standard environment, filters and checks
+. ./common.rc
+. ./common.filter
+
+# real QA test starts here
+_supported_fs xfs
+_supported_os Linux
+
+
+mkdir $TEST_DIR/ttt
+for n in {1..168}; do
+    touch $TEST_DIR/ttt/$n;
+done
+src/t_dir_offset $TEST_DIR/ttt
+
+# success, all done
+echo "*** done"
+rm -f $seq.full
+status=0
Index: xfstests/197.out
===================================================================
--- /dev/null   1970-01-01 00:00:00.000000000 +0000
+++ xfstests/197.out    2008-12-30 14:35:05.000000000 +0000
@@ -0,0 +1,2 @@
+QA output created by 197
+*** done

-- 

<Prev in Thread] Current Thread [Next in Thread>